/** \file grlib.h
 * \brief <      >
 * <      >
 * \par
 * \author ARV
 * \note <  >
 * \n :
 * \n \date	17.02.2012
 * \par
 * \version <>.	\n
 * Copyright 2012  ARV. All rights reserved.
 * \par
 *   :\n
 * 	-# WinAVR-20080411    
 *
 */


#ifndef GRLIB_H_
#define GRLIB_H_

#include <avr/pgmspace.h>
#include "T6963C.h"
#include "font.h"

typedef int coord_t;
typedef enum{
	DRAW_NORMAL,
	DRAW_INVERSE
} draw_mode_t;

typedef struct{
	uint8_t		width;
	uint8_t		height;
	uint8_t		bitmap[];
}image_t;

void view_page(uint8_t page);		//  
void set_page(uint8_t page);		//  
uint8_t active_page(void);
uint8_t viewed_page(void);

void clr_scr(void);

void pixel(coord_t x, coord_t y);

draw_mode_t draw_mode(draw_mode_t mode);

void move_to(coord_t x, coord_t y);		//   
void line_to(coord_t x, coord_t y);		//        
void circle(coord_t r);					//        
void fcircle(coord_t r);				//  
void rect(coord_t left, coord_t top, coord_t right, coord_t bottom);
void frect(coord_t left, coord_t top, coord_t right, coord_t bottom);
void set_clip_region(coord_t left, coord_t top, coord_t right, coord_t bottom);

void draw_image(image_t *img);
void draw_image_P(const image_t *img);

void draw_char(char c);
void draw_str(char *str);
void draw_str_P(const char *str);

void draw_vect_pic(const int8_t *ptr);

void print(char *str);
void print_P(const char *str);

#define fullscreen()	set_clip_region(0, 0, T6963C_PIXEL_WIDTH-1, T6963C_PIXEL_HEIGHT-1)

#endif /* GRLIB_H_ */
