/** \file menu.c
 * \brief <      >
 * <      >
 * \par
 * \author ARV
 * \note <  >
 * \n :
 * \n \date	04.03.2012
 * \par
 * \version <>.	\n
 * Copyright 2012  ARV. All rights reserved.
 * \par
 *   :\n
 * 	-# WinAVR-20080411    
 *
 */

#include <avr/io.h>
#include <avr/pgmspace.h>
#include <string.h>
#include "grlib.h"
#include "font.h"
#include "menu.h"

uint16_t text_len(char *txt){
	return strlen(txt) * SYMBOL_W;
}

uint16_t text_len_P(const char *txt){
	return strlen_P(txt) * SYMBOL_W;
}

void text_row(uint8_t xl, uint8_t yt, uint8_t width, uint8_t attr, char *txt){
	draw_mode_t old_mode = draw_mode(attr & ATTR_SELECTED ? DRAW_NORMAL : DRAW_INVERSE);

	set_clip_region(xl, yt, xl+width-1, yt+SYMBOL_H);
	frect(xl, yt, xl+width, yt+SYMBOL_H);
	draw_mode(attr & ATTR_SELECTED ? DRAW_INVERSE : DRAW_NORMAL);
	if(attr & ATTR_ALIGN_LEFT){
		xl++;
	} else if(attr & ATTR_ALIGN_RIGHT){
		xl = xl + width - 1 - text_len_P(txt);
	} else if(attr & ATTR_ALIGN_HCENTER){
		xl = xl + (width - 1 - text_len_P(txt)) / 2;
	}
	move_to(xl,yt+1);

	print_P(txt);
	fullscreen();
	draw_mode(old_mode);
}
